<?PHP



echo '<?xml version="1.0" encoding="UTF-8"?>

<urlset xmlns="http://www.google.com/schemas/sitemap/0.84">
';
$pDir = substr( $_SERVER["SCRIPT_NAME"], 0, strrpos( $_SERVER["SCRIPT_NAME"], "/")+1);
$URL = "http://".$_SERVER["SERVER_NAME"].$pDir;
$blacklist = array( "_privat", "archives");

//phpInfo();
$cwdir = getcwd()."/";
$items = array();
$items = read_dir_r( $cwdir, $items, array_flip( $blacklist));

foreach( $items as $item){
	$link = str_replace( $cwdir, $URL, $item);
	$time = date( "Y-m-d", filectime( $item));
	$freq = "daily";
	$prio = "0.8";
	echo "
	<url>
		<loc>".$link."</loc>
		<lastmod>".$time."</lastmod>
		<changefreq>".$freq."</changefreq>
		<priority>".$prio."</priority>
	</url>";
}

function read_dir_r( $dir, $items=array(), $blacklist=array()){
	$dh = @dir( $dir);
	if( !$dh){
		return $items;
	}
	$items[] = $dir;
	while( $file = $dh->read()){
		if( $file[0] == "." || isset( $blacklist[$file])){
			continue;
		}
		if( is_dir( $dir.$file)){
			$items = read_dir_r( $dir.$file."/", $items, $blacklist);
		}else{
			$items[] = $dir.$file;
		}
	}
	return $items;
}


?>

</urlset>
