<?PHP


/**
* jsLogger 20060219
* this is a side project of JSAX and SAXml
*
* Copyright (C) 2006 Florian Sax <flosax(at)users.sourceforge.net>
* jsLogger is protected by the GPL <http://www.gnu.org/copyleft/gpl.html>
* @param array array
*
* @return bool True on success else false
*/
function jsLogger( $array){
	if( isset( $array["TYPE"])){
		$file = $array["TYPE"];
	}else{
		$file = "log";
	}
	$conf = array(
		"dir" => "./",
		"end" => ".js.log",
		"sep" => ";;",
		"blacklist" => array( "PHPSESSID","TYPE"));
	$conf["blacklist"] = array_flip( $conf["blacklist"]);
	$path = $conf["dir"].$file.$conf["end"];
	if( !is_file( $path)){
		return false;
	}
	$fh = fopen( $path, "a");
	if( !$fh){
		return false;
	}
	$vars = array();
	while( list( $key, $val) = each( $array)){
		if( !isset( $conf["blacklist"][$key])){
			$vars[$key] = $val;
		}
	}
	$vars["IP"]		= $_SERVER["REMOTE_ADDR"];
	if( isset( $_SERVER["HTTP_REFERER"])){
		$vars["REFERER"]	= $_SERVER["HTTP_REFERER"];
	}
	$vars["AGENT"]		= $_SERVER["HTTP_USER_AGENT"];
	$vars["TIME"]		= date( "Ymd H:i:s");
	if( filesize( $path) < 2){
		if( !fwrite( $fh, implode( array_keys( $vars), $conf["sep"]).$conf["sep"]."\n")){
			return false;
		}
	}
	
	if( !fwrite( $fh, implode( $vars, $conf["sep"]).$conf["sep"]."\n")){
		return false;
	}
	return true;
}

if( jsLogger( @$_REQUEST)){
	echo "logged";
}else{
	echo "log failed";
}


?> 
