/**
* eventTools
* some event handling helpers
* eventTools doesn not work without JSAX
* written by Florian Sax 20051229
*
* eventTools is protected by the GPL <http://www.gnu.org/copyleft/gpl.html>
*/

if( !window.JSAX){
	alert( "eventTools need JavaScript Abstractions for X(HT)ML (objects/JSAX.js) to work.");
}
JSAX.Event = {
	Version: 20060227,

	solv: function( e){
		if( typeof( e) == "undefined"){
			var event = window.event;
		}else{
			var event = e;
			try{
				window.event = event;
			}catch( e){}
		}
		if( !event.target && event.srcElement){
			event.target = event.srcElement;
		}
		if( !event.charCode && event.keyCode){
			try{
				event.charCode = event.keyCode;
			}catch( e){}
		}
		if( !event.charCode && event.which){
			try{
				event.charCode = event.which;
			}catch( e){}
		}
		if( !event.clientX && event.x){
			event.clientX == event.x;
			event.clientY == event.y;
		}
		return event;
	},
	preventAction: function( e){
		var event = JSAX.Event.solv( e);
		event.cancelBubble = true;
		if( event.preventDefault){
			event.preventDefault();
		}
		return false;
	},

	listen: function( e){
		var event = JSAX.Event.solv( e);


//		var eventName = JSAX.Event.keyName( event);
		JSAX.Event.history[JSAX.Event.history.length] = event;
		JSAX.Event.history[event.type] = event;

		if( JSAX.CJSED){
			JSAX.CJSED.checkElem( event.target, event);
		}

//		JSAX.Event.history.push( event);
//		JSAX.OutPut.show( "type:"+event.type+" - which:"+event.which+" - charCode:"+event.charCode+" - keyCode:"+event.keyCode+" - name:"+eventName+" - targetTag:"+elem.tagName, 1);
	},

	startListen: function(){
		require( "Reference");
		try{
			JSAX.reference.Events.listeners;
		}catch( e){
			return false;
		}
		for( property in JSAX.reference.Events.listeners){
			document["on"+property] = JSAX.Event.listen;
		}
		return true;
	},

	keyName: function( e){
		if( e ){
			var event = e;
		}
		if( event.which){
			var num = event.which;
		}else{
			var num = event.keyCode;
		}
		if( event.which == 0){
			if( JSAX.Event.keys[event.charCode]){
				var eventName = JSAX.Event.keys[event.keyCode];
			}else{
				var eventName = "UNKNOWN";
			}
		}else if( JSAX.Event.keys[num]){
			var eventName = String.fromCharCode( num);
		}else{
			var eventName = JSAX.Event.keys[num];
		}
		if( typeof( eventName) == "undefined"){
			eventName = "UNKNOWN";
		}
		if( event.shiftKey){
			eventName = "Shift+"+eventName;
		}
		if( event.altKey){
			eventName = "Alt+"+eventName;
		}
		if( event.ctrlKey){
			eventName = "Ctrl+"+eventName;
		}
		if( event.metaKey){
			eventName = "Meta+"+eventName;
		}
		eventName.chopEnd( "+");

		return eventName;
	},

	history: new Array(),

	events: {

		MOUSEDOWN: 1,
		MOUSEUP: 2,
		MOUSEOVER: 4,
		MOUSEOUT: 8,
		MOUSEMOVE: 16,
		MOUSEDRAG: 32,
		CLICK: 64,
		DBLCLICK: 128,
		KEYDOWN: 256,
		KEYUP: 512,
		KEYPRESS: 1024,
		DRAGDROP: 2048,
		FOCUS: 4096,
		BLUR: 8192,
		SELECT: 16384,
		CHANGE: 32768,
		BUTTON: 65535,
		RESET: 65536,
		SUBMIT: 131072,
		SCROLL: 262144,
		LOAD: 524288,
		UNLOAD: 1048576,
		XFER_DONE: 2097152,
		ABORT: 4194304,
		ERROR: 8388608,
		LOCATE: 16777216,
		MOVE: 33554432,
		RESIZE: 67108864,
		FORWARD: 134217728,
		HELP: 268435456,
		BACK: 536870912,
		TEXT: 1073741824
	},

	nonChar: {
	},

	keys: {
		MOUSEMOVE: 47085,
		MOUSEDOWN: 1,
		MOUSEUP: 2,
		CONTEXTMENU: 3,
		MOUSEOVER: 4,
		HELP: 6,

		KEY_BACK_SPACE: 8,
		KEY_TAB: 9,
		KEY_CLEAR: 12,
		KEY_RETURN: 13,
		KEY_ENTER: 14,
		KEY_SHIFT: 16,
		KEY_CONTROL: 17,
		KEY_ALT: 18,
		KEY_PAUSE: 19,
		KEY_CAPS_LOCK: 20,

		KEY_ESCAPE: 27,

		KEY_SPACE: 32,

		KEY_PAGE_UP: 33,
		KEY_PAGE_DOWN: 34,
		KEY_END: 35,
		KEY_HOME: 36,
		KEY_LEFT: 37,
		KEY_UP: 38,
		KEY_RIGHT: 39,
		KEY_DOWN: 40,
		KEY_PRINTSCREEN: 44,
		KEY_INSERT: 45,
		KEY_DELETE: 46,

		KEY_CONTEXT_MENU: 93,

		KEY_NUMPAD0: 96,
		KEY_NUMPAD1: 97,
		KEY_NUMPAD2: 98,
		KEY_NUMPAD3: 99,
		KEY_NUMPAD4: 100,
		KEY_NUMPAD5: 101,
		KEY_NUMPAD6: 102,
		KEY_NUMPAD7: 103,
		KEY_NUMPAD8: 104,
		KEY_NUMPAD9: 105,
		KEY_SEPARATOR: 108,
		KEY_F1: 112,
		KEY_F2: 113,
		KEY_F3: 114,
		KEY_F4: 115,
		KEY_F5: 116,
		KEY_F6: 117,
		KEY_F7: 118,
		KEY_F8: 119,
		KEY_F9: 120,
		KEY_F10: 121,
		KEY_F11: 122,
		KEY_F12: 123,
		KEY_F13: 124,
		KEY_F14: 125,
		KEY_F15: 126,
		KEY_F16: 127,
		KEY_F17: 128,
		KEY_F18: 129,
		KEY_F19: 130,
		KEY_F20: 131,
		KEY_F21: 132,
		KEY_F22: 133,
		KEY_F23: 134,
		KEY_F24: 135,
		KEY_NUM_LOCK: 144,
		KEY_SCROLL_LOCK: 145,
		KEY_PERIOD: 190,
		KEY_META: 224
	},

	start: function(){
//		var events = {};
//		for( var eventName in JSAX.Event.events){
//			var num = JSAX.Event.events[eventName];
//			events[num] = eventName;
//		}
//		JSAX.Event.events = JSAX.object.glue( JSAX.Event.events, events);
//		
//		var keys = {};
//		for( var keyName in JSAX.Event.keys){
//			var num = JSAX.Event.keys[keyName];
//			keys[num] = keyName;
//		}
//		JSAX.Event.keys = JSAX.object.glue( JSAX.Event.keys, keys);

		if( JSAX.CJSED){
			JSAX.Event.startListen();
		}
	}

};
JSAX.Event.start();


