/**
* OutPut.js
* a simple output, usefull instead of alert or as loading message
* written by Florian Sax 20060121
*
* Copyright (C) 2006 Florian Sax <flosax(at)users.sourceforge.net>
* OutPut is protected by the GPL <http://www.gnu.org/copyleft/gpl.html>
*/

if( !window.JSAX){
	alert( "OutPut is not able to work without JavaScript Abstractions for X(HT)ML (objects/JSAX.js).");
}

require( "DOM", "compat/browser_msie", "Opacity");
JSAX.OutPut = {
	Version: 20060121,
	style: {
		top:		100,
		left:		200,
		fadetime:	0.15,
		zIndex:		999//,
//		border:		"2px solid black",
//		background:	"#C0C0C0",
//		color:		"black",
//		font:		"monospace 12px"
//		align:		"middle"
	},

	show: function( item){
		var OutPut = byId(  "myOutPut");
		if( !OutPut){
			OutPut		= document.createElement( "div");
			OutPut.id	= "myOutPut";
			OutPut.onclick 	= function( e){
				JSAX.OutPut.hide();
				JSAX.Event.preventAction( e);
			};
			for( var prop in JSAX.OutPut.style){
				OutPut.style[prop] = JSAX.OutPut.style[prop];
			}
			document.body.appendChild( OutPut);
			OutPut		= byId(  "myOutPut");
		}
		OutPut.innerHTML	= item+"<br/>";
		if( JSAX.OutPut.style.align == "middle"){;
			OutPut.style.top	= "-999px";
			OutPut.style.left	= "-999px";
			OutPut.style.display	= "block";
			var posY	= window.innerHeight/2 -OutPut.offsetHeight/2;
			var posX	= window.innerWidth/2 -OutPut.offsetWidth/2;
		}else{
			var posY	= JSAX.OutPut.style.top;
			var posX	= JSAX.OutPut.style.left;
		}
		posX 		+= document.body.scrollLeft;
		posY 		+= document.body.scrollTop;
		OutPut.style.top	= posY+"px";
		OutPut.style.left	= posX+"px";
		OutPut.style.display	= "block";
		if( JSAX.OutPut.style.fadetime && OutPut.style.opacity == 0){
			JSAX.Opacity.fade( "myOutPut", 80, JSAX.OutPut.style.fadetime);
		}

		if( arguments[1]){
			setTimeout( "JSAX.OutPut.hide();", arguments[1]*1000);
		}
	},

	hide: function(){
		if( JSAX.OutPut.style.fadetime){
			JSAX.Opacity.fade( "myOutPut", 0, JSAX.OutPut.style.fadetime);
		}else{
			OutPut.style.display	= "hidden";
		}
	}
};


