/**
* ContextMenu
*
*  written by Florian Sax
*/



if( !window.JSAX){
	alert( "contextMenu needs JavaScript Abstractions for X(HT)ML (objects/JSAX.js) to work.");
}
require( "Event", "detectBrowser");

JSAX.cMenu = {
	Version: 20060202,

/*
* creates a contextMenu button and returns the HTML
*/
mFAct: function( actName){
	var act = JSAX.cMenu.actions[actName];
	return "<div id=\"cMenu_"+actName+"\" class=\"cMenuButton\" onmouseover=\"this.className='cMenuButton over'\" onmouseout=\"this.className='cMenuButton'\" onclick=\""+act+"\">"+actName+"</div>";
},

/**
* creates and shows the contextMenu of the submitted element
*/
show: function( e){
	if( JSAX.cMenu.blocker==true){
		return;
	}
	JSAX.cMenu.hide();
	JSAX.cMenu.mousePos( e);

	var ContextMenu = document.getElementById( "ContextMenu");
	if( !ContextMenu){
		JSAX.cMenu.start();
		ContextMenu = document.getElementById( "ContextMenu");
	}

	var mouseX = JSAX.cMenu.mouseX;
	var mouseY = JSAX.cMenu.mouseY;

	if( JSAX.browser.msie()){
		if( document.documentElement && document.documentElement.scrollTop){ //IE "strict"
			var scrollLeft = parseInt( document.documentElement.scrollLeft);
			var scrollTop = parseInt( document.documentElement.scrollTop);
			var winW = parseInt( document.documentElement.clientWidth);
			var winH = parseInt( document.documentElement.clientHeight);
		}else{ //IE "quirk"
			var scrollLeft = parseInt( document.body.scrollLeft);
			var scrollTop = parseInt( document.body.scrollTop);
			var winW = parseInt( document.body.clientWidth);
			var winH = parseInt( document.body.clientHeight);
		}
	}else{
		var scrollLeft = parseInt( window.pageXOffset);
		var scrollTop = parseInt( window.pageYOffset);
		var winW = parseInt( window.innerHeight);
		var winH = parseInt( window.innerHeight);
	}
	JSAX.cMenu.value = this.id;

	// put new content into cMenu
	var HTML = "";
	JSAX.cMenu.status = this.id;
//	HTML = "<div class=title>"+this.id+"</div>";
	for( i = 0; i < items.length; i++){
		HTML += JSAX.cMenu.mFAct( items[i]);
	}
	ContextMenu.innerHTML = "<div class='cMenuBox'>"+HTML+"</div>";
	ContextMenu.style.left = "-999px";
	ContextMenu.style.top = "-999px";
	ContextMenu.style.display = "block";

	// position and view cMenu
	var cMenuW = parseInt( ContextMenu.offsetWidth);
	var cMenuH = parseInt( ContextMenu.offsetHeight);
	if( mouseX +cMenuW > winW)mouseX -= cMenuW;
	if( mouseY +cMenuH > winH)mouseY -= cMenuH;
	if( mouseX <= 0)mouseX = scrollLeft;
	if( mouseY <= 0)mouseY = scrollTop;
	mouseX += scrollLeft;
	mouseY += scrollTop;
	if( !JSAX.browser.msie() && !JSAX.browser.mozi()){
		mouseX -= 7;
		mouseY -= 7;
	}
	ContextMenu.style.left = mouseX+"px";
	ContextMenu.style.top = mouseY+"px";

	setTimeout( "document.body.onclick=hide;", 1);
	setTimeout( "document.body.oncontextmenu=hide;", 1);
	setTimeout( "window.cMenu_blocker=false;", 1);
	JSAX.cMenu.blocker=true;
	return;
},

hide: function(){
	var ContextMenu = document.getElementById( "ContextMenu");
	ContextMenu.style.display = "none";
	JSAX.cMenu.satus = null;
	document.body.onclick = null;
	document.body.oncontextmenu = JSAX.Event.preventAction;
//	ContextMenu.style.left = -999;
//	ContextMenu.style.top = -999;
	return;
},

/**
* this function evaluates the mouse position and makes it avilable in 'window.mouse(X/Y)'
*/
mousePos: function( e){
	var event = JSAX.Event.solv( e);
	JSAX.cMenu.mouseX = event.clientX;
	JSAX.cMenu.mouseY = event.clientY;
},


start: function(){

	var ContextMenu = document.createElement( "div");
	ContextMenu.id = "ContextMenu";
	ContextMenu.className = "cMenu";
	document.body.appendChild( ContextMenu);

	JSAX.cMenu.hide();

	document.body.onmousemove = JSAX.cMenu.mousePos;
	document.body.onclick = JSAX.cMenu.show;
}
};

//if(window.attachEvent)window.attachEvent('onload', cMenu_begin);
//else if(window.addEventListener)window.addEventListener('load', cMenu_begin, false);
