/**
* JSAX.input
* 
* written by Florian Sax 20060204
*
* Copyright (C) 2006 Florian Sax <flosax(at)users.sourceforge.net>
* JSAX.input is protected by the GPL <http://www.gnu.org/copyleft/gpl.html>
*/



if( !window.JSAX){
	alert( "JSAX.input is not able to work without JavaScript Abstractions for X(HT)ML (objects/JSAX.js).");
}


require( "proto/Element", "Event", "code");
JSAX.input = {
	Version: 20060204,

	slider: {
		make: function( elem){
			var sliderFrame = document.createElement( "div");
			sliderFrame.style.background = "pics/sliderBG.gif";
			var slider = document.createElement( "img");
			slider.style.left = parseInt( elem.returnValue());
			slider.config = { };
			slider.onmousedown = function( e){
				var event = JSAX.Event.solv( e);
				this.config = {
					type: "horizontal",
					target: elem
				};
				this.config.mousePos.X = event.clientX;
				this.config.mousePos.Y = event.clientY;
				window.focusElement = this;
				window.onmousemove = function( e){
					var event = JSAX.Event.solv( e);
					var elem = focusElement;
					var difX = event.clientX -elem.config.mousePos.X;
					var difY = event.clientY -elem.config.mousePos.Y;
					if( elem.config.type.substr( 0, 1).toUpperCase() == "H"){
						elem.style.left = parseInt( elem.style.left) +difX;
						elem.config.target.value = parseInt( elem.style.left);
					}else{
						elem.style.top = parseInt( elem.style.top) +difY;
						elem.config.target.setValue = parseInt( elem.style.top);
					}
					elem.config.mousePos.X = event.clientX;
					elem.config.mousePos.Y = event.clientY;
					return JSAX.Event.preventAction( event);
				};
				window.onmouseup = function( e){
					var event = JSAX.Event.solv( e);
					var elem = focusElement;
					window.onmousemove = "";
					window.onmousedown = "";
					return JSAX.Event.preventAction( event);
				};
			}
			sliderFrame.slider = slider;
			return sliderFrame;
		}
	},
	decimal: {
		make: function( inputElem){
			input.onchange = function(){
				this.value = parseNumber( this.value);
			};
			input.onkeypress = input.onchange;
			
		}
	}
};


