/**
* compat.png_alpha
* makes alpha transparancy of png's compatibel to M$IE
* written by Florian Sax 20060222
*
* compat.png_alpha is protected by the GPL <http://www.gnu.org/copyleft/gpl.html>
*/

if( !window.JSAX){
	window.JSAX = {};
}
if( !JSAX.compat){
	JSAX.compat = {};
}

JSAX.compat.PNG_alpha = {
	Version: 20060228,

	replaceImages: function(){
		if( typeof( document.body.runtimeStyle) == "undefined"){
			return false;
		}
		var ae = document.getElementsByTagName( "*");
		if( ae.length < 1){
			ae = document.all;
		}
		var s = 0;
		for( var i = 0; i < ae.length; i++){
			if( ae[i].src && ae[i].src.toLowerCase().indexOf( ".png") > 1){
				JSAX.compat.PNG_alpha.doImage( ae[i]);
				s++;
			}else if( ae[i].style.background && ae[i].style.background.toLowerCase().indexOf( ".png") > 1){
				JSAX.compat.PNG_alpha.doBG( ae[i]);
				s++;
			}
		}
		return s;
	},

	doBG: function( elem){

		if( elem.style.background.toLowerCase().indexOf( "url") != -1){
			var img = elem.style.background.substring(
				elem.style.background.indexOf( "(") +1,
				elem.style.background.indexOf( ")"));
			if( elem.runtimeStyle.filter.indexOf( img) > 1){
				return;
			}

			elem.runtimeStyle.background = "";
			elem.runtimeStyle.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(enabled=true, sizingMethod='crop', src='"+img+"')";
		}
		return;
	},

	cssProperties: ["height", "width", "border", "cursor"],
	doImage: function( elem){

		if( elem.tagName.toLowerCase() == "img"){
			if( elem.parentNode.runtimeStyle.filter.indexOf( elem.src) > 1){
				return;
			}
			if( elem.parentNode.tagName.toLowerCase() != "span"
			 || elem.parentNode.runtimeStyle.filter.toLowerCase().indexOf( ".png") == -1){
				var cont = document.createElement( "span");
				elem.parentNode.insertBefore( cont, elem);
				cont.appendChild( elem);
			}
			if( elem.className)elem.parentNode.className = elem.className;
			for( var i = 0; i < JSAX.compat.PNG_alpha.cssProperties.length; i++){
				var prop = JSAX.compat.PNG_alpha.cssProperties[i];
				if( elem.style[prop]){
					elem.parentNode.runtimeStyle[prop] = elem.style[prop];
				}
			}
			elem.runtimeStyle.filter = "progid:DXImageTransform.Microsoft.Alpha(opacity=0)";
			elem.parentNode.runtimeStyle.display = "inline-block";
			elem.parentNode.runtimeStyle.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(enabled=true, sizingMethod='scale', src='"+elem.src+"')";
		}
		return;
	},

	runId: false
};


if( navigator.userAgent.toLowerCase().indexOf( "msie") != -1
 && navigator.userAgent.toLowerCase().indexOf( "opera") == -1){
	JSAX.compat.PNG_alpha.runId = setInterval( "JSAX.compat.PNG_alpha.replaceImages();", 1000);
}


