/**
* JSAX.proto.Object
*
* written by Florian Sax @20051219
*/

if( !window.JSAX){
	alert( "Object.js needs JavaScript Abstractions for X(HT)ML (objects/JSAX.js) to work.");
}

if( !window.Object){
	window.Object = {};
}
if( !Object.prototype){
	Object = Object.constructor;
}

JSAX.proto.Object = {
	"JSAX.proto.Object Version": 20060208,

	fusionMe: function( object){
		for( var i = arguments.length; i > 0; i--){
			JSAX.object.attachTo( arguments[i-1], this);
		}
		return this;
	},

	fusionIt: function( object){
		for( var i = arguments.length; i > 0; i--){
			JSAX.object.attachTo( this, arguments[i-1]);
		}
		return this;
	},

	concat: function( object){
		var obj = this;
		for( var i = arguments.length; i > 0; i--){
			obj = JSAX.object.concat( obj, arguments[i-1]);
		}
		return obj;
	},

	duplicate: function(){
		return JSAX.object.concat( this);
	},

	objectType: function(){
	var obj = this;
//	return typeof( obj); // enable this line to disable the array
	if( obj === null){
		return "null";
	}
	if( typeof( obj) == "undefined"){
		return "undefined";
	}
	if( typeof( obj) == "object"){
		if( typeof( obj.tagName) == "string"){
			str = "element";
		}else if( obj instanceof Array){
			str = "array";
		}else{
			str = typeof( obj);
		}
	}else{
		str = typeof( obj);
	}
	return str;
	}
};

JSAX.object.attachTo( JSAX.proto.Object, Object.prototype);




