/**
* JSAX.All
* Gathered by Florian Sax under the GPL <http://www.gnu.org/copyleft/gpl.html>
*/

if( !window.JSAX){
	alert( "JSAX.All is not able to work without JavaScript Abstractions for X(HT)ML (objects/JSAX.js).");
}

JSAX.All = {
	Version: 20060317,
	
/**
* JSAX.All.inclide - Includes all known JSAX objects. This should only be used for development
*/
	include: function(){
		var s = 0;
		var f = 0;
		for( var i = 0; i < JSAX.All.JSAXfiles.length; i++){
			require( JSAX.All.JSAXfiles[i]) ? s++ : f++;
		}
		return s;
	},

/**
* JSAX.All.JSAXfiles - A list of all known JSAX objects
*/
	JSAXfiles: [
	// proto
		"proto/Array",
		"proto/Element",
		"proto/Number",
		"proto/Object",
		"proto/String",
//		"proto/wild",
	// compat
		"compat/Selection",
		"compat/browser_msie",
		"compat/png_alpha",
		"compat/browser",
	// comming
		"comming/GUI/listWidget",
		"comming/runtime",
		"comming/CSS",
	// GUI
		"GUI/colorTool/colorTool",
		"GUI/DOMinfo/DOMinfo",
		"GUI/JSDoc/JSDoc",
		"GUI/toolBar/toolBar",
		"GUI/TOC/TOC",
	//
		"AE.js",
//		"All",
		"benchmark",
		"Cascade",
		"CJSED",
		"code",
		"Color",
		"Cookie",
		"CSV",
		"detectBrowser",
		"DOM",
		"Event",
//		"JSAX",
		"LinkRep",
		"Opacity",
		"OutPut",
		"overImg",
		"Reference",
		"RQ",
		"WFM"]

};