/**
* LinkRep
* This object should replace real links (<a href="">) wich can be followed by google with ajax links.
* The ajax links replace only the content of a element instead of reloading the whole page.
*
* written by Florian Sax 20060131 <flosax(at)users.sourceforge.net>
* Copyright (C) 2005 Florian Sax
*
* LinkRep is protected by the GNU General Public License <http://www.gnu.org/copyleft/gpl.html>
*/



if( !JSAX){
	JSAX = {};
}


JSAX.LinkRep = {
	Version: 20060131,
	triggers: {},
/*		"?content=": function( aTag){ // all "a" tags with " ajaxTargetId=:..." will be replaced
			var link = aTag.href.str_replace( JSAX.LinkRep.linkCorrection[0], "?content=", "?call=");// you only wan the content/ call. not the whole page
			document.getElementById( "content").innerHTML = read( link);
			JSAX.LinkRep.replaceLinksInElem( aTag.ajaxTargetElem);
		}
		"http://sourceforge.net/": function( aTag){
			require( "WFM");
			JSAX.WFM.open( aTag.href, aTag.title ? aTag.title : aTag.innerHTML);
		},
		"/objects/": JSAX.WFM.open},
*/

	start: function(){
		JSAX.LinkRep.replaceLinksInElem( document.body);
	},

	replaceLinksInElem: function( elem){
		links = elem.getElementsByTagName( "a");
		for( var e=0; e<links.length; e++){
			for( var trig in JSAX.LinkRep.triggers){
				if( links[e].href.indexOf( trig) != -1){
					links[e].URL = links[e].href;
					links[e].target = "";
					links[e].onclick = JSAX.LinkRep.click;
				}
			}
		}
	},
	click: function( e){
		this.href = this.URL;
		for( var trig in JSAX.LinkRep.triggers){
			if( this.href.indexOf( trig) != -1){
				JSAX.LinkRep.triggers[trig]( this);
			}
		}
		JSAX.LinkRep.lastElem = this;
		this.href = "javascript:;";
		setTimeout( "JSAX.LinkRep.lastElem.href = JSAX.LinkRep.lastElem.URL", 1);
		return true;
	}

};


