/**
* JSAX JS Reference
* Gathered by Florian Sax under the GPL <http://www.gnu.org/copyleft/gpl.html>
*/

if( !window.JSAX){
	alert( "The reference is not able to work without JavaScript Abstractions for X(HT)ML (objects/JSAX.js).");
}

JSAX.reference = {
	Version: 20060108,

CSS: {
	properties: new Array( "background", "background-attachment", "background-color", "background-image", "background-position", "background-repeat", "border", "border-top", "border-right", "border-bottom", "border-left", "border-collapse", "border-color", "border-top-color", "border-right-color", "border-bottom-color", "border-left-color", "border-spacing", "border-style", "border-top-style", "border-right-style", "border-bottom-style", "border-left-style", "border-width", "border-top-width", "border-right-width", "border-bottom-width", "border-left-width", "bottom", "caption-side", "clear", "clip", "color", "content", "counter-increment", "counter-reset", "cursor", "direction", "display", "empty-cells", "float", "font", "font-family", "font-size", "font-style", "font-variant", "font-weight", "height", "left", "letter-spacing", "line-height", "list-style", "list-style-image", "list-style-position", "list-style-type", "margin", "margin-top", "margin-right", "margin-bottom", "margin-left", "max-height", "max-width", "min-height", "min-width", "orphans", "outline", "outline-color", "outline-style", "outline-width", "overflow", "padding", "padding-top", "padding-right", "padding-bottom", "padding-left", "page-break-after", "page-break-before", "page-break-inside", "position", "quotes", "right", "table-layout", "text-align", "text-decoration", "text-indent", "text-transform", "top", "unicode-bidi", "vertical-align", "visibility", "white-space", "widows", "width", "word-spacing", "z-index")
}

,
DOM: {
},
standaloneFunctions: {
	"parseInt": {},
	"parseFloat": {},
	"parseNumber": {},
	"parseString": {},
	"typeof": {},
	"instanceof": {}
},
Objects: {
	Boolean: {
	},
	Number: {
		"JSAX.proto": JSAX.proto.Number
	},
	Math: {
		
	},
	Array: {
		push: {
			0: "Object" },
		pop: {},
		shift: {},
		unshift: {},
		join: {},
		"JSAX.proto": JSAX.proto.Array
	},
	String: {
		indexOf: {
			0: "indexOf( StringTofind)" },
		lastIndexOf: {
			0: "StringToFind" },
		search: {
			0: "RegExp" },
		substr: {
			0: "intStart, intEnd" },
		substring: {
			0: "intStart, intEnd" },
		fromCharCode: {
			0: "Event.which" },
		"JSAX.proto": JSAX.proto.String
	},
	RegExp: {
		match: {}
	},
	Date: {
	},
	Node: {
	},
	Element: {
		"JSAX.proto": JSAX.proto.Element
	},
	Object: {
		"JSAX.proto": JSAX.proto.Object
	},
	Function: {
	}
},
Events: {
	neededlisteners: {
		mousemove: {},
		mousedown: {},
		mouseup: {},
		keydown: {},
		keyup: {},
		scroll: {},
		submit: {}
		
	},
	listeners: {
		mousemove: {},
		mousedown: {},
		mouseup: {},
		mouseover: {},
		mouseout: {},
		dragstart: {},
		dragend: {},
		click: {},
		contextmenu: {},
		keydown: {},
//		keyup: {},
		keypress: {},
		scroll: {},
		submit: {}
		
	}
}
};