/*=WebFrameManager=0.12========================================_=[]=X
|                                                                   |
|     fully compatible with Mozilla, Konqueror and M$IE             |
|                                                                   |
|                                                                   |
|  written by Florian Sax <sax@startseite.ch> copyleft 01. 02. 2004 |
|                     this script is OpenSource(visite www.gnu.org) |
|__________________________________________________________________*/


require( "Event", "DOM", "detectBrowser", "compat/browser_msie", "proto/String");
JSAX.WFM = {
	Version: 20060211,

style: {
	win:	{
		background:	'#E0E0E0',
		margin:		4,
		width:		600,
		height:		400
	},
	res:	{
		width:		160,
		height:		40,
		thick:		6,
		background:	'#AACCFF'
	},
	bar:	{
		height: 	20,
		background:	'#AACCFF',
		color:		'#444444'
	}
},
config: {
	frameWidth	: 600,
	frameHeight	: 400,
	border		: 4,
	resizeWidth	: 160,
	resizeHeight	: 40,
	resizeThick	: 8,
	barHeight	: 25,
	backColor	: '#E0E0E0',
	frontColor	: '#AACCFF',
	textColor	: '#444444'
},


buttons: [
	['JSAX.WFM.hide',	'_'],
	['JSAX.WFM.fullScreen',	'[ ]'],
	['JSAX.WFM.close',	'X']],

top: 10,


/**
* open the submitted url as new window
*
* @param string URLorElem - The URL or Element wich should be loaded in the WF
* @param string [title]   - The Id of the WF
* @param string [params]  - Additional parameters
*/
open: function( URLorElem, title, params){
	if( !byId( 'taskBar')){
		JSAX.WFM.start();
		JSAX.WFM.startElem = URLorElem;
		setTimeout( "JSAX.WFM.open( JSAX.WFM.startElem, '"+arguments[1]+"', '"+arguments[2]+"');", 200);
		return;
	}
	var HTML = false;
	var elem = false;
	var URL  = false;
	if( typeof( URLorElem) == "string"){
		if( URLorElem.indexOf( "<") != -1
		 || URLorElem.length > 511){
			HTML = URLorElem;
		}else{
			URL  = URLorElem;
		}
	}else{
		if( URLorElem.tagName){
			elem = URLorElem;
			if( elem.tagName.toLowerCase() == "a"){
				URL = elem.href;
			}else{
				elem = URLorElem;
			}
			if( !title || title == "undefined"){
				if( elem.title){
					var title = elem.title;
				}else{
					var title = elem.innerHTML.stripTags().substr( 0, 128);
				}
			}
			if( URL){
				elem = false;
			}
		}else{
			return;
		}
	}

	
	if( title && title != "undefined"){
		var id = title;
	}else{
		if( URL){
			var id = URL;
		}else if( HTML){
			var id = "HTML";
		}else if( elem.title){
			var id = elem.title;
		}else if( elem.id){
			var id = elem.id;
		}else{
			var id = elem.tagName;
		}
	}
	var chopChars = ['"', '=', "'"];
	id = id.stripTags();
	for( var i=0; i < chopChars.length; i++){
		if( id.indexOf( chopChars[i]) != -1){
			id = id.trimSplit( chopChars[i])[0]+"";
		}
	}
	var illegalChars = [
		["&nbsp;", " "], 
		["\n", " "],
		["\t", " "],
		[" ", " "],
		["*", ""],
		["+", ""],
		["  ", " "],
		["  ", " "]];
	for( var i=0; i < illegalChars.length; i++){
		id = id.str_replace( illegalChars[i][0], illegalChars[i][1]);
	}
	if( id > 255){
		id = id.substr( 0, 255);
	}

	// recive parameters
	if( arguments[2] && arguments[2] != "undefined"){
		var config = JSAX.WFM.getParams( arguments[2]);
	}else{
		var config = JSAX.WFM.config;
	}

	var newId = id.trim();
	var i = 1;
	while( byId( newId+'_win')){
		i++;
		newId = id+' ('+i+')';
	}
	id = newId;
//	alert( "\""+id+"\"");

	var winId = id+'_win';
	var wBarId = id+'_wBar';
	var resizeId = id+'_resize';

	var resizeY = config.resizeHeight -config.resizeThick;
	var wBar = '<table id="'+wBarId+'" name="'+id+'" cellpadding="0" cellspacing="1">'+
		'<td id="'+id+'_title" name="'+id+'" onmousedown="JSAX.WFM.beginDrag( this.id);" style="cursor: move;">'+
		id+
//			'<form onsubmit="byId('+frmId+').src=this.'+id+'_input.value;"><input id="'+id+'_input" name="'+id+'_input" value="'+id+'"><input type=submit value=get></form>'+
			'</td>';
	for( var i = 0; i < JSAX.WFM.buttons.length; i++){
		var key   = JSAX.WFM.buttons[i][0];
		var value = JSAX.WFM.buttons[i][1];
		wBar += '<td onclick="'+key+'( \''+id+'\');" id="'+id+'_'+key+'" style="font: bold 14px sans-serif; width: 22px; background: '+config.backColor+'; vertical-align: middle;" valign="middle" align="center">'+value+'</td>';
	}
	wBar += '</table>';

	var resize = '<div align=right name="'+id+'" id="'+resizeId+'" onmousedown="JSAX.WFM.beginDrag( this.id);" cellpadding="0" cellspacing="0" style=" cursor: se-resize;">'+
		'<div style="width: '+config.resizeThick+'px; height: '+resizeY+'px; background: '+config.frontColor+'; font: 0px;"></div>'+
		'<div style="width: 100%; height: '+config.resizeThick+'px; background: '+config.frontColor+'; font: 0px;"></div></div>';

	var frmId = id+'_frm';
	if( URL){
		var frame = '<iframe id="'+frmId+'" frameborder="0" marginheight="0" marginwidth="0" src="'+URL+'"></iframe>';
	}else{
		var frame = '<div id="'+frmId+'" style="overflow: scroll;"></div>';
	}


	var html = wBar+frame+resize;

	var win		= document.createElement( 'div');
	win.config	= config;
	win.id		= winId;
	win.name	= id;
	win.className	= 'WFM_Container';
	win.style.padding	= 0;
	win.style.position	= 'absolute';
	win.style.left		= window.mouseX;
	win.style.top		= window.mouseY;
	win.style.background	= config.backColor;
	win.innerHTML		= '<div style="position: relative">'+html+'</div>';
	win.style.zIndex	= JSAX.WFM.top++;

	win.show = function( e){
		var wins = document.getElementsByClassName( 'WFM_Container');
		for( var i = 0; i < wins.length; i++){
			if( wins[i].id != this.id){
				var el = wins[i];
				if( el.style.zIndex >= this.style.zIndex){
					el.style.zIndex = el.style.zIndex -1;
				}
				if( !JSAX.browser.mozi()
				 && !JSAX.browser.msie()
				 && el.frm.tagName.toLowerCase() == "iframe"){
					JSAX.WFM.hideElem( el.frm);
				}
			}
		}
		this.style.zIndex = JSAX.WFM.top -1;
		JSAX.WFM.showElem( this.frm);
//		alert( this.frm.style.left);
	};
	win.hide = function( e){
		var wins = document.getElementsByClassName( 'WFM_Container');
		if( wins.length > 1){
			var elem = wins[0];
			for( var i = 0; i < wins.length; i++){
				if( wins[i].id != this.id){
					var el = wins[i];
					if( el.style.zIndex > elem.style.zIndex
					 && el.style.visibility != "hidden"){
						elem = el;
					}else if( elem.id == this.id){
						elem = el;
					}
					if( el.style.zIndex >= this.style.zIndex){
						el.style.zIndex = el.style.zIndex -1;
					}
				}
			}
			if( elem.style.visibility != "hidden"){
				JSAX.WFM.showElem( elem.frm);
			}
		}
		JSAX.WFM.hideElem( this);
		JSAX.WFM.hideElem( this.frm);
		this.style.zIndex = JSAX.WFM.top -1;
		this.onclick = "";
		setTimeout( "if( byId( '"+this.id+"'))byId( '"+this.id+"').onclick = byId( '"+this.id+"').show;", 1);
	};
	win.onclick = win.show;
//	win.onmousemove = win.show;

	// hide the other frames if the browser does not support iframe zIndexing
	if( !JSAX.browser.mozi() && !JSAX.browser.msie()){
		var wins = document.getElementsByClassName( 'WFM_Container');
		for( var i = 0; i < wins.length; i++){
			var el = byId( wins[i].name+"_frm");
			if(  el.tagName.toLowerCase() == "iframe"){
				JSAX.WFM.hideElem( el);
			}
		}
	}
	document.body.appendChild( win);

	win.frm = byId( frmId);
	if( !URL){
		if( elem){
			win.frm.appendChild( elem);
		}else{
			win.frm.innerHTML = HTML;
		}
	}else{
		if( JSAX.browser.konq() || JSAX.browser.msie()){
			win.frm.src = URL;
		}
	}

	win.bar = byId( wBarId);
	win.res = byId( resizeId);

	win.frm.style.position		= 'absolute';
	win.frm.style.left		= config.border;
	win.frm.style.top		= config.barHeight +config.border *2;
	win.frm.style.width		= config.frameWidth;
	win.frm.style.height		= config.frameHeight;
	win.frm.style.background	= config.backColor;

	win.res.name	= id;

	win.style.width			= config.frameWidth +config.border *2;
	win.style.height		= config.frameHeight +config.barHeight +config.border *3;

	var posXlimit = document.body.clientWidth +document.body.scrollLeft -win.offsetWidth -config.resizeThick;
	var posYlimit = document.body.clientHeight +document.body.scrollTop -win.offsetHeight -config.resizeThick;
	if( win.offsetLeft > posXlimit){
		win.style.left		= posXlimit;
	}
	if( win.offsetTop > posYlimit){
		win.style.top		= posYlimit;
	}
	
	win.bar.style.position		= 'absolute';
	win.bar.style.left		= config.border;
	win.bar.style.top		= config.border;
	win.bar.style.height		= config.barHeight;
	win.bar.style.width		= config.frameWidth;
	win.bar.style.cursor		= 'default';
	win.bar.style.color		= config.textColor;
	win.bar.style.border		= '1 solid '+config.backColor;
	win.bar.style.background	= config.frontColor;
//	win.bar.style.font-weight	= 'bold';

	win.res.style.position		= 'absolute';
	win.res.style.width		= config.resizeWidth;
	win.res.style.height		= config.resizeHeight;
	win.res.style.left		= config.frameWidth +config.border *2 -config.resizeWidth +config.resizeThick;
	win.res.style.top		= config.frameHeight +config.barHeight -config.resizeHeight +config.resizeThick +config.border *3;
	win.res.style.zIndex		= -1;
/*
	win.res.onmouseover = function( e){
		this.style.zIndex	= 10;
//		byId( this.name+"_frm").style.zIndex = -1;
	};
	win.res.onmouseout = function( e){
		this.style.zIndex	= -1;
	};
*/
//		byId(id+'_input').style.border = '1 solid '+.config.backColor;
//		byId(id+'_input').style.spacing = 0;
//		byId(id+'_input').style.background = config.frontColor;

	

	return true;
},

/**
* makes the WF window by id fullscreen or back to the size before
*/
fullScreen: function( myId){

	var win = byId( myId+'_win');

	if( !win){
		return;
	}

	if( win.res.style.display == 'none'){
		win.style.left           = win.config.left;
		win.style.top            = win.config.top;
		win.res.style.display    = 'block';
		JSAX.WFM.resizeWin( win);
		return;
	}

	var winWidth  = window.innerWidth;
	var winHeight = window.innerHeight;

	var winPosX = document.body.scrollLeft;
	var winPosY = document.body.scrollTop;

	if( JSAX.browser.mozi() || JSAX.browser.opera()){
		winHeight -= 15;
		winWidth -= 16;
	}

	var contY = win.frm.offsetTop;
	var objW  = winWidth -win.config.border *2;

	win.bar.style.width = objW;

	JSAX.WFM.actualizeView();

	win.config.left  = win.offsetLeft;
	win.config.top   = win.offsetTop;

	win.frm.style.width  = objW;
	win.frm.style.height = winHeight -contY -win.config.border;

	win.style.width  = winWidth;
	win.style.height = winHeight;
	win.style.left   = winPosX;
	win.style.top    = winPosY;

	win.res.style.display	= 'none';

	JSAX.WFM.actualizeView();
	window.scroll( winPosX, winPosY);

	win.show();

	return JSAX.Event.preventAction();
},

/**
* close window with submitted id
*/
close: function( id){
	var win = byId( id+'_win');
	win.hide();
	document.body.removeChild( win);
	JSAX.WFM.top--;
	JSAX.WFM.actualizeView();
},

/**
* hide window with submitted id
*/
hide: function( myId){
	var win = byId( myId+'_win');
	if( !win){
		return false;
	}
	if( win.style.visibility == 'hidden'){
		return true;
	}
	var taskBar = byId( 'taskBar');
	if( !taskBar){
		JSAX.WFM.start();
		taskBar = byId( 'taskBar');
	}
	byId( 'tskBar').style.display = 'block';

	var td = document.createElement( 'td');
	td.id = myId+'_margin';
	td.style.background = win.config.frontColor;
	td.style.color = win.config.textColor;
	taskBar.appendChild( td);
	var button = '<div id="'+myId+'_reveal" onclick="JSAX.WFM.reveal( \''+myId+'\');" style="width: 100%; height: '+win.config.barHeight+';">'+myId+'</div>';
	byId( myId+'_margin').innerHTML = button;

//	window.scroll( 0, 0);

	win.hide();

	JSAX.WFM.actualizeView();
//	alert( document.getElementsByClassName( 'WFM_Container')[0].frm.style.left);
//	alert( document.getElementsByClassName( 'WFM_Container')[1].frm.style.left);
	return false;
},

/**
* reveal window with submitted id
*/
reveal: function( myId){
	var win = byId(myId+'_win');
	if( !win){
		return false;
	}
	JSAX.WFM.showElem( win);
	var taskBar = byId( 'taskBar');
	if( byId( myId+'_margin')){
		taskBar.removeChild( byId( myId+'_margin'));
	}
	if( !taskBar.childNodes.length){
		byId( 'tskBar').style.display = "none";
	}
	var winPosX = win.offsetLeft;
	var winPosY = win.offsetTop;

	window.scroll( winPosX, winPosY);
	win.show();
	JSAX.WFM.actualizeView();
},


/**
* the following 4 functions are for window movement & resize
*/
beginDrag: function( targetId){
	// hide all frame for better performance
	var myId = byId( targetId).getAttribute( 'name');
	var win = byId( myId+'_win');

	win.show();
	var wins = document.getElementsByClassName( 'WFM_Container');
	for( var i = 0; i < wins.length; i++){
		var el = byId( wins[i].name+"_frm");
		if( el.tagName.toLowerCase() == "iframe"){
			JSAX.WFM.hideElem( el);
		}
	}
	
	JSAX.WFM.lastX = window.mouseX;
	JSAX.WFM.lastY = window.mouseY;
	JSAX.WFM.curId = myId;

	if( targetId == myId+'_resize'){
		byId( myId+'_resize').style.zIndex = 10;
		JSAX.WFM.dragMode = 'resize';
	}else{
		JSAX.WFM.dragMode = 'drag';
	}

	document.onmousemove	= JSAX.WFM.doDrag;
	document.onmouseup	= JSAX.WFM.endDrag;

//	JSAX.OutPut.show( JSAX.WFM.dragMode, 1);

	return JSAX.Event.preventAction();
},

doDrag: function( e){	

	var myId = JSAX.WFM.curId;

	var difX	= window.mouseX -JSAX.WFM.lastX;
	var difY	= window.mouseY -JSAX.WFM.lastY;

	var minimumX	= 0;//80+parseInt( frm.left);
	var minimumY	= 0;//50+parseInt( frm.top);

	var elem = byId( myId+'_win');
	if( JSAX.WFM.dragMode == 'resize'){
		elem = elem.res;
	}else{
		minimumX = -1000;
	}

	var newX	= elem.offsetLeft +difX;
	var newY	= elem.offsetTop +difY;
	if( newX < minimumX){
		newX = minimumX;
	}
	if(newY < minimumY){
		newY = minimumY;
	}

	elem.style.left	= newX;
	elem.style.top	= newY;

	JSAX.WFM.lastX	= window.mouseX;
	JSAX.WFM.lastY	= window.mouseY;

//	JSAX.OutPut.show( JSAX.WFM.dragMode+" to X: "+newX+" Y: "+newY, 1);

	return JSAX.Event.preventAction( e);
},

endDrag: function( e){

	var myId = JSAX.WFM.curId;

	// review all frames wich were hidden for better performance
	var wins = document.getElementsByClassName( 'WFM_Container');
	for( var i = 0; i < wins.length; i++){
		var el = byId( wins[i].name+"_frm");
		if( JSAX.browser.mozi()
		 || JSAX.browser.msie()
		 || wins[i].name == myId
		 || el.tagName.toLowerCase() != "iframe"){
			JSAX.WFM.showElem( el);
		}
	}

	if( JSAX.WFM.dragMode == 'resize'){
		JSAX.WFM.resizeWin( byId( myId+'_win'));
		byId( myId+'_resize').style.zIndex = -1;
	}
	JSAX.WFM.dragMode  = '';
	document.onmousemove = null;
	document.onmouseup   = null;

	JSAX.WFM.actualizeView();
	return JSAX.Event.preventAction( e);
},

resizeWin: function( win){
//	win.res.style.zIndex = -1;

	var posX = win.res.offsetLeft +win.config.resizeWidth -win.config.resizeThick;
	var posY = win.res.offsetTop +win.config.resizeHeight -win.config.resizeThick;
//	var dragW = win.res.style.width);
//	var dragH = win.res.style.height);
//	var contX = win.frm.style.left);
	var contY = win.frm.offsetTop;
//	var titlH = win.bar.style.height);
	var objW = posX -win.config.border *2;

	win.bar.style.width = objW;

	win.frm.style.width  = objW;
	win.frm.style.height = posY -contY -win.config.border;

	win.style.width  = posX;
	win.style.height = posY;
},

/**
* this function solves the config parameters in open( URLorElem, name, parameters)
*/
getParams: function( params){
	var array = params.trimSplit( ",");
	var params = new Array()
	for( var i = 0; i < array.length; i++){
		if( !array[i].length){
			continue;
		}
		array[i] = array[i].trimSplit( "=");
		if( typeof( array[i][1]) == "undefined"){
			params[array[i][0]] = true;
		}else{
			params[array[i][0]] = array[i][1];
		}
	}

	for( var key in JSAX.WFM.config){
		if( typeof( params[key]) == "undefined"){
			params[key] = JSAX.WFM.config[key];
		}else{
			params[key] = params[key];
		}
	}
	return params;
},


hideElem: function( elem){
	if( elem.style.visibility == "hidden"){
		return;
	}
	elem.style.visibility = "hidden";
	if( JSAX.browser.konq()){
		elem.oldLeft = parseInt( elem.style.left);
		elem.style.left = "-9999px";
	}else{
		elem.style.display = "none";
	}
},
showElem: function( elem){
	if( elem.style.visibility == ""){
		return;
	}
	elem.style.visibility = "";
	if( JSAX.browser.konq()){
		elem.style.left = elem.oldLeft+"px";
	}else{
		elem.style.display = "";
	}
	return;
//	alert( elem.id);
},


actualizeView: function(){
	if( JSAX.browser.opera()){
		// this line is just here to get sure the things are going to be refreshed
//		byId( 'taskBar').innerHTML = byId( 'taskBar').innerHTML+'';
	}
},


mMove: function( e){
	var event = JSAX.Event.solv( e);
	window.mouseX = event.clientX +document.body.scrollLeft;
	window.mouseY = event.clientY +document.body.scrollTop;
//	JSAX.WFM.placeTaskBar( e);
},

placeTaskBar: function(){
	var tskBar = byId( 'tskBar');
	if( !tskBar){
		JSAX.WFM.start();
		return;
	}
	if( tskBar.style.display == "none"){
		return;
	}
//	if( !JSAX.browser.msie()){
//	}else{
//		var top = parseInt( document.body.clientHeight);
//	}

	var top  = document.body.scrollTop +window.innerHeight -tskBar.offsetHeight;
	var width = window.innerWidth;
	var oldH = document.body.scrollHeight;
	var oldW = document.body.scrollWidth;
	if( JSAX.browser.mozi() || JSAX.browser.opera()){
		top -= 15;
		width -= 16;
	}
//	alert( top);
	tskBar.style.width = width+'px';
	tskBar.style.top   = top+'px';
	tskBar.style.left  = document.body.scrollLeft+'px';
	return;
	
},

start: function(){
	if( !document.body){
		return;
	}
	var height =  JSAX.WFM.config.barHeight +JSAX.WFM.config.border *2;
	var taskBar = document.createElement( "div");
	taskBar.id			= "tskBar";
	taskBar.innerHTML		= '<table width="100%" cellpadding="0" cellspacing="'+JSAX.WFM.config.border+'"><tr id="taskBar"></tr></table>';
	taskBar.style.cursor		= "default";
	taskBar.style.position		= "fixed";
	taskBar.style.left		= "0px";
	taskBar.style.bottom		= "0px";
	taskBar.style.width		= "100%";
	taskBar.style.height		= height+"px";
	taskBar.style.background	= JSAX.WFM.config.backColor;
	taskBar.style.display		= "none";
	
	
	if( !window.mouseX){
		window.mouseX = 0;
		window.mouseY = 0;
	}
	document.body.appendChild( taskBar);
	try{
		document.body.onmousemove	= JSAX.WFM.mMove;
//		document.body.onscroll		= JSAX.WFM.placeTaskBar;
	}catch( e){
	}
}
};

/*
if( window.attachEvent){
	window.attachEvent( 'onload', JSAX.WFM.start);
}else if( window.addEventListener){
	window.addEventListener( 'load', JSAX.WFM.start, false);
}*/