/**
* innerSize.js
* this is a collection of usefull javascript functions
* written by Florian Sax 20051219
*
* innerSize.js is protected by the GPL <http://www.gnu.org/copyleft/gpl.html>
*/



JSAX.compat.innerSize = {
	onWindowResize: function(){
		if( document.body && document.body.clientHeight){
			window.innerHeight = document.body.clientHeight;
			window.innerWidth  = document.body.clientWidth;
		}else{
			window.innerHeight = 0;
			window.innerWidth  = 0;
		}
	},
	windowCheck: function(){
		if( window.innerHeight != document.body.clientHeight
		 || window.innerWidth != document.body.clientWidth){
			JSAX.compat.innerSize.onWindowResize();
		}
	}
}

if( typeof( window.innerWidth) == "undefined"){ // for M$IE
	JSAX.compat.innerSize.onWindowResize();
	setInterval( "JSAX.compat.innerSize.windowCheck();", 1000);
};